/*
 * Validation Mail sender
 *
 * Name: Charles R. Grosvenor Jr. aka MirrorShades
 * Date: October 1, 1994
 * Written for (_)rsan at the Bear's Cave.
 *
 * 	This program reads in an ASCII file and replaces %1, %2 with the
 * strings that are represented by them.  Wordwrap is enabled by placing a
 * dash at the end of each line to word wrap.  The result is a PLAIN TEXT
 * ASCII file with the proper info and proper margins set.  This is useful
 * for sending validation mail to people.  This program can also be used
 * in conjunction with a mass mailer or some such thing to create
 * personalized lists.  That is why it's being distributed as freeware
 * with the source code. If you use this program, please send me email
 * and let me know what you think.
 *
 * The following are the parameters in use currently:
 *
 * %1 -=- Real Name
 * %2 -=- User Name
 * %3 -=- Phone
 * %4 -=- Street
 * %5 -=- City
 * %6 -=- State
 * %7 -=- Country
 * %8 -=- Zip Code
 * %9 -=- Password
 * %A -=- First On
 * %B -=- Age
 * %C -=- Birthday
 * %D -=- User Number
 *
 *
 * Please do not modify this program and distribute the modified versions.
 *
 * CRG -=- 10-06-94 -=- Added User Number and the Syntax for Commands screen
 */

#define VERSION "1.1"
#define LINE_LENGTH 75

#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <dos.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

typedef struct {

    char
      name[31],       /* user's name/handle */
      realname[21],   /* user's real name */
      callsign[7],    /* user's amateur callsign */
      phone[13],      /* user's phone number */
      dataphone[13],  /* user's data phone */
      street[31],     /* street address */
      city[31],       /* city */
      state[3],       /* state code [MO, CA, etc] */
      country[4],     /* country [USA, CAN, FRA, etc] */
      zipcode[11],    /* zipcode [#####-####] */
      pw[9],          /* user's password */
      laston[9],      /* last date on */
      firston[9],     /* first date on */
      note[61],       /* sysop's note about user */
      macros[3][81],  /* macro keys */
      sex;            /* user's sex */

    char
      res_char[78];   /* bytes for more strings */

    unsigned char
      age,            /* user's age */
      inact,          /* if deleted or inactive */
      comp_type,      /* computer type */
      defprot,        /* deflt transfer protocol */
      defed,          /* default editor */
      screenchars,    /* screen width */
      screenlines,    /* screen height */
      num_extended,   /* extended description lines */
      optional_val,   /* optional lines in msgs */
      sl,             /* security level */
      dsl,            /* transfer security level */
      exempt,         /* exempt from ratios, etc */
      colors[10],     /* user's colors */
      bwcolors[10],   /* user's b&w colors */
      votes[20],      /* user's votes */
      illegal,        /* illegal logons */
      waiting,        /* number mail waiting */
      ontoday,        /* num times on today */
      month,          /* birth month */
      day,            /* birth day */
      year,           /* birth year */
      language;       /* language to use */


    char
	 res_byte[33];   /* reserved for byte values */
                  char  spin1,
                        spin2,
                        spin3,
			spin4;
         unsigned char passdate[9];            /* Tell them every 30 days passowrd mod */
	 unsigned char user_warn;              /* Give a yell if a shithead is on */
	 unsigned char ranktype;			    /* use custom rank or not */
	 unsigned char doorlimit;		    /* user's limit */
	 unsigned char doorcounter;            /* user's door counter */


    unsigned short
      homeuser,       /* user number where user can be found */
      homesys,        /* system where user can be found */
      forwardusr,     /* mail forwarded to this user number */
      forwardsys,     /* mail forwarded to this system number */
      net_num,        /* net num for forwarding */
      msgpost,        /* number messages posted */
      emailsent,      /* number of email sent */
      feedbacksent,   /* number of f-back sent */
      fsenttoday1,    /* feedbacks today */
      posttoday,      /* number posts today */
      etoday,         /* number emails today */
      ar,             /* board access */
      dar,            /* directory access */
      restrict,       /* restrictions on account */
      ass_pts,        /* bad things the user did */
      uploaded,       /* number files uploaded */
      downloaded,     /* number files downloaded */
      lastrate,       /* last baud rate on */
      logons,         /* total number of logons */
      emailnet,       /* email sent via net */
      postnet,        /* posts sent thru net */
      deletedposts,   /* how many posts deleted */
      chainsrun,      /* how many "chains" run */
      gfilesread,     /* how many gfiles read */
      banktime,       /* how many mins in timebank */
      homenet;        /* home net number */

   char
     res_short[48];   /* reserved for short values */

    unsigned long
      msgread,        /* total num msgs read */
      uk,             /* number of k uploaded */
      dk,             /* number of k downloaded */
      daten,          /* numerical time last on */
      sysstatus,      /* status/defaults */
      wwiv_regnum,    /* user's WWIV reg number */
      filepoints;     /* points to spend for files */

    char
      res_long[56];   /* reserved for long values */

    float
      timeontoday,    /* time on today */
      extratime,      /* time left today */
      timeon,         /* total time on system */
      pos_account,    /* $ credit */
      neg_account,    /* $ debit */
      gold;           /* game money */

    char
      res_float[32];  /* reserved for real values */

    char
      res_gp[100];    /* reserved for whatever */

} userrec;

void usage(void);
int load_user(char *user_file_name, char *user_name);
int exist(char *s);
void npr( char *fmt, ... );
void make_file(FILE *the_output_file, char *infile_name);
char *parse_line(char *input_line, int starting_out_pos);

userrec user;
int user_number=0;

void usage(void)
/* Name       :  usage
 * Purpose    :  prints command line help for incorrect command lines
 * Revision   :  November 3, 1994 -=- Charles R. Grosvenor Jr. -=- Level 0
 */
{
    npr("\r\nCorrect format is:\r\n");
    npr("VMAIL.EXE <User number or Name> <Input.Msg> <Output.Msg> <DATA\USER.LST>\r\n\r\n");
    npr("Where:\r\n");
    npr(" <User Number or Name>     is the user to make the file for.\r\n");
    npr(" <Input.Msg>               is the file with the codes to be decoded.\r\n");
    npr(" <Output.Msg>              is the file that is generated.\r\n");
    npr(" <DATA\USER.LST>           is the full path and file name to the User.lst\r\n");
    npr("\r\n");
}

void main(int argc, char **argv)
/* Name       : main
 * Dependicies: the voids in the program
 * Purpose    :  Initalizes the parameters and then calls the rest of the voids
 * Revision   :  October 18, 1993 -=- Charles R. Grosvenor Jr. -=- Level 0
 */
{
  FILE *output_file;

  npr("\r\nValidation Mail for SNAIL Mail. Reflections Software, Version: %s\r\n",
	VERSION);
  npr("Written exclusivly by MirrorShades, Ya wear 'em on your face.\r\n");
  npr("For the Beast of the East, Bear's Cave, (_)rsan.\r\n");
  /* initalize pointers */

  /*read user file and determine age */
  if (argc>4)
  {
    if ( (exist(argv[2])) && (exist(argv[4])) )
    {
      if ( (output_file=fopen(argv[3], "wb"))==NULL)
      {
	npr("Unable to create the output file %s.\r\n",argv[3]);
      }
      else
      {
	/* everything should be fine if we can load the user info here */
	if (load_user(argv[4], argv[1]))
	{ /* shit, we found a loser to send this to! make the file! */
	  make_file(output_file, argv[2]);
	  fclose(output_file);
	}
      }
    }
    else
    {
      if (!exist(argv[2]))
	npr("Unable to load the input file: %s.\r\n", argv[2]);
      if (!exist(argv[4]))
	npr("Unable to load the user.lst: %s.\r\n", argv[4]);
    }
  }
  else
  {
    npr("\r\nNot enough command line arguments.\n");
    usage();
    exit(1);
  }
}


int load_user(char *user_file_name, char *user_name)
/* Name       :  load_users
 * Dependicies:  needs the name of the user records, username to search for
 * Purpose    :  Load a user record into memory based on either Number or Name
 * Revision   :  October 18, 1993 -=- Charles R. Grosvenor Jr. -=- Level 0
 */

{
  int user_file;
  int user_found=0;
  int bytes_read;
  int loopcount=0;
  int search_number=0;

  search_number=atoi(user_name);

  if ( (user_file=open(user_file_name,O_RDONLY | O_BINARY)) == -1)
  {
    npr("Need a valid user file.  %s could not be opened.\n", user_file_name);
    return(user_found);
  }
  else
  {
    while ( (!eof(user_file)) && !(user_found) )
    {
      if ((bytes_read = read(user_file,(void *)&user,sizeof(userrec))) == -1)
      {
	npr("File read error with user file.\n");
        close(user_file);
	return(user_found);
      }
      else
      if (bytes_read!=sizeof(userrec))
      {
	npr("Invalid user file dimensions.  Possibly a different version of WWIV.\n");
	npr("File read error with user file.\n");
	close(user_file);
	return(user_found);
      }
      else
      if ((!user.inact) && (loopcount>=1))
      {  /* here's where we check for either a user name or number */
	if ( (stricmp(user_name, user.name)==0) || (search_number==loopcount) )
	{
	  npr("\r\nUser found!, %s\r\n\r\n",user.name);
	  user_found=1;
	  user_number=loopcount;
	}
      }
      loopcount++;
    }
    close(user_file);
  }
  return(user_found);
}

void npr( char *fmt, ... )
/*
 * Purpose : Format a list of parameters into a single string and display
 *
 * Revision: Level 0 -=- Dan Walters
 *           Level 1 -=- Charles R. Grosvenor Jr., 7/1/94
 */
{
  va_list v;
  static char s[512];

  va_start( v, fmt );
  vsprintf( s, fmt, v );
  va_end( v );
#ifdef IBM_COLOR
  cprintf("%s",s);
#else
  printf("%s",s);
#endif
}

int exist(char *s)
/* Name        : int exist()
 * Dependencies: s, the file to look for
 * Purpose     : Checks to see if a file exists at the path specified.
 * Revision    : October 18, 1994 -=- Charles R. Grosvenor Jr. -=- Level 0
 */
{
  int f;

  f=open(s,O_RDONLY | O_BINARY);
  close(f);
  if (f>0)
    return(1);
  else
    return(0);
}

void make_file(FILE *the_output_file, char *infile_name)
/* Name        : void make_file()
 * Dependencies: parse_line, used to place the proper strings in
 * Purpose     : Reads the input file and creates the output file
 * Revision    : October 18, 1994 -=- Charles R. Grosvenor Jr. -=- Level 0
 */
{
  FILE *infile;
  char line[81], output_line[241];
  int previous_line, backwards_loop;

  if ((infile=fopen(infile_name, "rb"))==NULL)
  {
    npr("Unable to load the input file\r\n");
  }
  else
  {
    previous_line=0;
    while ( (fgets(line, 80, infile)!=NULL) && (!feof(infile)) )
    {
      strcpy(output_line, parse_line(line, previous_line));
      fwrite(output_line, strlen(output_line), 1, the_output_file);
      if (output_line[strlen(output_line)-1]==' ')
      {
	backwards_loop=strlen(output_line)-2;
	while ( (output_line[backwards_loop]!='\n') && (backwards_loop) )
	{
	  backwards_loop--;
	}
	if (backwards_loop)
	  previous_line=strlen(output_line)-backwards_loop;
	else
	  previous_line=0;
      }
      else
      {
	previous_line=0;
      }
    }
    fclose(infile);
  }
}

char *parse_line(char *input_line, int starting_out_pos)
/* Name        : char *parse_line()
 * Dependencies: input_line, the line to add strings to
 *               starting_out_pos, keeps track of output line
 * Purpose     : Replaces parameters with the proper info.
 * Revision    : October 18, 1994 -=- Charles R. Grosvenor Jr. -=- Level 0
 *               November 6, 1994 -=- Charles R. Grosvenor Jr. -=- Level 1
 *                 Added the user number to the list of options.
 */
{
  static char output_line[241], append_string[61];
  int parse=0, pos_loop=0, output_loop_pos=0, backwards_loop, append_loop;

  if (input_line[strlen(input_line)-3]=='-')
  {
    parse=1;
    input_line[strlen(input_line)-3]='\0';
  }
  else
  {
    input_line[strlen(input_line)-2]='\0';
  }

  while (pos_loop<strlen(input_line))
  {
    if (input_line[pos_loop]!='%')
    {
      if ( ((output_loop_pos+starting_out_pos)%LINE_LENGTH) ||
	   (output_loop_pos==0) )
      {
	output_line[output_loop_pos]=input_line[pos_loop];
	output_loop_pos++;
	pos_loop++;
      }
      else
      {
	backwards_loop=output_loop_pos-1;
	while (output_line[backwards_loop]!=' ')
	{
	  output_line[backwards_loop+1]=output_line[backwards_loop];
	  backwards_loop--;
	}
	output_line[backwards_loop]='\r';
	output_line[backwards_loop+1]='\n';
	output_loop_pos++;
	output_line[output_loop_pos]=input_line[pos_loop];;
	pos_loop++;
	output_loop_pos++;
      }
    }
    else
    {
      pos_loop++;
	append_string[0]='\0';
	switch (input_line[pos_loop])
	{
	  case '%':  /* user only wanted a % sign */
		     strcpy(append_string, "%");
		     break;
	  case '1':  /* User's ALIAS */
		     strcpy(append_string, user.name);
		     break;
	  case '2':  /* User's Real Name */
		     strcpy(append_string, user.realname);
		     break;
	  case '3':  /* User's phone */
		     strcpy(append_string, user.phone);
		     break;
	  case '4':  /* User's street */
		     strcpy(append_string, user.street);
		     break;
	  case '5':  /* User's City */
		     strcpy(append_string, user.city);
		     break;
	  case '6':  /* User's State */
		     strcpy(append_string, user.state);
		     break;
	  case '7':  /* User's country */
		     strcpy(append_string, user.country);
		     break;
	  case '8':  /* User's Zip-Code */
		     strcpy(append_string, user.zipcode);
		     break;
	  case '9':  /* User's password */
		     strcpy(append_string, user.pw);
		     break;
	  case 'A':  /* User's first on */
	  case 'a':  /* User's first on */
		     strcpy(append_string, user.firston);
		     break;
	  case 'B':  /* User's Age */
	  case 'b':  /* User's Age */
		     sprintf(append_string, "%d", (int)user.age);
		     break;
	  case 'C':  /* User's birthday */
	  case 'c':  /* User's birthday */
		     sprintf(append_string, "%d/%d/%d",
			      user.day, user.month, user.year);
		     break;
	  case 'D':
	  case 'd':  /* User's NUMBER */
		     sprintf(append_string, "%d",
			      user_number);
		     break;
	  default :  /* not found, just output the % and letter */
		     append_string[0]='%';
		     append_string[1]=input_line[pos_loop];
		     append_string[2]='\0';
		     break;
	}
	append_loop=0;
	while (append_loop<strlen(append_string))
	{ /* here's where the parameter is added */
	  if ( ((output_loop_pos+starting_out_pos)%LINE_LENGTH) ||
	       (output_loop_pos==0) )
	  {
	    output_line[output_loop_pos]=append_string[append_loop];
	    output_loop_pos++;
	    append_loop++;
	  }
	  else
	  {
	    backwards_loop=output_loop_pos-1;
	    while (output_line[backwards_loop]!=' ')
	    {
	      output_line[backwards_loop+1]=output_line[backwards_loop];
	      backwards_loop--;
	    }
	    output_line[backwards_loop]='\r';
	    output_line[backwards_loop+1]='\n';
	    output_loop_pos++;
	    output_line[output_loop_pos]=append_string[append_loop];;
	    append_loop++;
	    output_loop_pos++;
	}
      }
	pos_loop++;
    }
  }
  output_line[output_loop_pos]='\0';

  if (parse)
  {
    strcat(output_line, " ");
  }
  else
  {
    strcat(output_line, "\r\n");
  }
  return(&(output_line[0]));
}

